/* audit.c -- This file contains the audit system extensions
 *
 * Copyright 2005 Red Hat Inc., Durham, North Carolina.
 * All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Authors:
 *     Steve Grubb <sgrubb@redhat.com>
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <libaudit.h>
#include "audit.h"

int audit_fd = -1;
static int audit_this = 0;


void auditable_event(int i)
{
	audit_this = i;
}


void audit_exit(int status)
{
	if (audit_this) {
		audit_log_user_message(audit_fd, AUDIT_USYS_CONFIG, 
			"changing system time", NULL, NULL, NULL, status ? 0 : 1);
		close(audit_fd);
	}
	exit(status);
}

